<?php
/*************************************************************************************/
/*                                                                                   */
/*                                  CREATE FRONTEND                                  */
/*                                                                                   */
/*************************************************************************************/

function cmm_display_menu($ID) {
	global $wpdb;
	$query = "SELECT t.term_id FROM $wpdb->term_taxonomy AS t WHERE t.term_taxonomy_id = $ID";
	$p = $wpdb->get_results($query);
	foreach($p as $item) {
		$term_ID = $item->term_id;
	}

	//Retrieve a list of published menu elements order by their specified Order attribute. The function requires the ID of the menu to be listed.
	$menu_items = cmm_list_items_of_menu($ID);
	$cmm_color_scheme = get_option( 'cmm_color_scheme_value' );
	$cmm_menu_effect = get_option( 'cmm_menu_effect_value' );
	$cmm_menu_type = get_option( 'cmm_menu_type_value' );
	$cmm_menu_dd_style = get_option( 'cmm_menu_dd_style' );

	//Initialize return value
	$ret = '';
	if (count($menu_items)) {
		if ($cmm_menu_type[$term_ID] == 'horizontal') {
			//Display a horizontal menu
			if($cmm_menu_dd_style[$term_ID] == 'dark') {
				$menu_type = "cmm-menu-horizontal-dark";
			} else {
				$menu_type = "cmm-menu-horizontal-light";
			}
		} else if($cmm_menu_type[$term_ID] == 'vertical-left') {
			//Display a vertical, right-pointing menu
			if($cmm_menu_dd_style[$term_ID] == 'dark') {
				$menu_type = "cmm-menu-vertical-dark";
			} else {
				$menu_type = "cmm-menu-vertical-light";
			}
		} else {
			//Display a vertical, left-pointing menu
			if($cmm_menu_dd_style[$term_ID] == 'dark') {
				$menu_type = "cmm-menu-vertical-right-dark";
			} else {
				$menu_type = "cmm-menu-vertical-right-light";
			}
		}

		//Open the menu container list
		if(!empty($menu_items)){
			$ret .= '<div id="wrapper-'.$menu_type.'">';
			$ret .= '<ul id="'.$menu_type.'" class="menu_'.$cmm_color_scheme[$term_ID].'">';
			$cnt = 0;
				foreach($menu_items as $item) {
					//Determine whether the main menu item has an own link or not
					$link = get_post_meta($item->ID, "cmm_menu_item_link_value", $single = true);

					//Retrieve the menu item width value
					$dd_style = get_post_meta($item->ID, "cmm_column_width_value", $single = true);

					//Determine whether the current item is a right aligned one or not
					$right_aligned = get_post_meta($item->ID, "cmm_menu_item_alignement_value", $single = true);
					if ($right_aligned == 'checked') {
						$right_inside = ' align_right ';
					} else {
						$right_inside = '';
					}
					
					if ($dd_style == 'nodrop' && $right_aligned == 'checked') {
						$list_style = ' class="right nodrop"';
					} else if($dd_style == 'nodrop' && $right_aligned != 'checked') {
						$list_style = ' class="nodrop"';
					} else if($dd_style != 'nodrop' && $right_aligned == 'checked') {
						$list_style = ' class="right"';
					} else if($dd_style == 'fullwidth') {
						$list_style = ' class="fullwidth"';
						if(!$cnt) {
							$dd_style = 'fullwidth first_fullwidth';
						}
					} else {
						$list_style = '';
					}

					
					if($dd_style != 'nodrop') {
						//The current element has a dropdown list
						//Open new list element for each condifgured menu item
						$ret .= '<li'.$list_style.'><a href="'.$link.'" class="drop">'.$item->post_title.'</a>';
						//Add a container div for the dropdown content based on the set dropdown style
						$ret .= '<div class="dropdown_'.$dd_style.$right_inside.'">';

						//Add the drop-down content iself
						$ret .= do_shortcode($item->post_content);
						
						//Close container div holding the doropdown content
						$ret  .= '</div>';
					} else {
						//Open new list element for each condifgured menu item
						$ret .= '<li'.$list_style.'><a href="'.$link.'">'.$item->post_title.'</a>';
				}
						
				//Close list element
				$ret .= '</li>';
				$cnt++;
			}
	
			//Close the menu container list
			$ret .= '</ul>';
			$ret .= '</div>';
		}
	}
	echo $ret;
}

function cmm_list_items_of_menu($taxonomy_id) {
	global $wpdb;
	
	$query = "SELECT p.post_title, p.post_content, p.ID
					FROM $wpdb->posts AS p
					JOIN $wpdb->term_relationships AS t
					ON p.ID = t.object_id
					WHERE p.post_status = 'publish'
					AND p.post_type = 'cmm'
					AND t.term_taxonomy_id = $taxonomy_id
					ORDER BY menu_order ASC
				";

	$p = $wpdb->get_results($query);
	
	return $p;
	
}

//Enqueue stylesheet
function cmm_stylesheet() {
    $cmm_style_url_1 = WP_PLUGIN_URL . '/css-mega-menu/css/megamenu.css';
    $cmm_style_file_1 = WP_PLUGIN_DIR . '/css-mega-menu/css/megamenu.css';
    if ( file_exists($cmm_style_file_1) ) {
        wp_register_style('cmm_style_sheet_1', $cmm_style_url_1);
        wp_enqueue_style( 'cmm_style_sheet_1');
    }

	if(isIE6() > 0) {
		$cmm_style_url_4 = WP_PLUGIN_URL . '/css-mega-menu/css/ie6.css';
		$cmm_style_file_4 = WP_PLUGIN_DIR . '/css-mega-menu/css/ie6.css';
		if ( file_exists($cmm_style_file_4) ) {
			wp_register_style('cmm_style_sheet_4', $cmm_style_url_4);
			wp_enqueue_style( 'cmm_style_sheet_4');
		}
		add_action( 'wp_head', 'build_ie6_inline_style' );
	}

	if(isIE() > 0) {
		$cmm_style_url_5 = WP_PLUGIN_URL . '/css-mega-menu/css/ie.css';
		$cmm_style_file_5 = WP_PLUGIN_DIR . '/css-mega-menu/css/ie.css';
		if ( file_exists($cmm_style_file_5) ) {
			wp_register_style('cmm_style_sheet_5', $cmm_style_url_5);
			wp_enqueue_style( 'cmm_style_sheet_5');
		}
	}
	
	$cmm_color_schemes = get_option( 'cmm_color_scheme_value' );
	$cnt = 9;
	if(!empty($cmm_color_schemes)){
		foreach ($cmm_color_schemes as $jcs) {
			$cmm_style_url[$cnt] = WP_PLUGIN_URL . '/css-mega-menu/css/colors/'.$jcs.'.css';
			$cmm_style_file[$cnt] = WP_PLUGIN_DIR . '/css-mega-menu/css/colors/'.$jcs.'.css';
			if ( file_exists($cmm_style_file[$cnt]) ) {
				wp_register_style('cmm_style_sheet_'.$cnt, $cmm_style_url[$cnt]);
				wp_enqueue_style( 'cmm_style_sheet_'.$cnt);
			}
			$cnt++;
		}
	}
}
add_action('wp_print_styles', 'cmm_stylesheet');

?>