<?php
/* Register the widget */
function cmm_load_widgets() {
	register_widget( 'CMM_Widget' );
}

/* Begin Widget Class */
class CMM_Widget extends WP_Widget {

	/* Widget setup  */
	function CMM_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'CMM_Widget', 'description' => __('A widget that allows the user to include a CSS Mega Menu in their sidebar', 'cmmw') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 250, 'height' => 250, 'id_base' => 'cmm-widget' );

		/* Create the widget. */
		$this->WP_Widget( 'cmm-widget', __('CSS Mega Menu Widget', 'cmmw'), $widget_ops, $control_ops );
	}
	
	/* Display the widget  */
	function widget( $args, $instance ) {
		extract( $args );
		$menuid = $instance['ID'];
		
		if ( $menuid != '') {
			cmm_display_menu($menuid);
		} else {
			echo 'Please specify a menu ID in the CSS Mega Menu Widget settings'; //If no URL inputed
		}
	}
	
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* Strip Tags For Text Boxes */
		$instance['ID'] = strip_tags( $new_instance['ID'] );

		return $instance;
	}
	
	function form( $instance ) {
		/* Set up some default widget settings. */
		$defaults = array( 
			'ID' => __('', 'cmmw'),
		);
	
		$instance = wp_parse_args( (array) $instance, $defaults );
?>
		<h3>General Settings</h3>
		<!-- Widget ID: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'ID' ); ?>"><?php _e('Menu ID:', 'cmmw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'ID' ); ?>" name="<?php echo $this->get_field_name( 'ID' ); ?>" value="<?php echo $instance['ID']; ?>" style="width:85%;" />
		</p>
<?php
	}
}

/* Load the widget */
add_action( 'widgets_init', 'cmm_load_widgets' );

?>