(function() {
	// Load plugin specific language pack
//	tinymce.PluginManager.requireLangPack('multifeed');
	tinymce.create('tinymce.plugins.multifeedfields', {
		/**
		 * Initializes the plugin, this will be executed after the plugin has been created.
		 * This call is done before the editor instance has finished it's initialization so use the onInit event
		 * of the editor instance to intercept that event.
		 *
		 * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
		 * @param {string} url Absolute URL to where the plugin is located.
		 */
		init : function(ed, url) {
			// Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand('mceExample');
/*			ed.addCommand('mcemultifeedfields', function() {
			//alert('aaa');
				jQuery("#otherMenu").toggle().offset(jQuery('#content_multifeedfields').offset());
			});

			// Register example button
			ed.addButton('multifeedfields', {
				title : 'multifeedflds.desc',
				cmd : 'mcemultifeedfields',
				image : url + '/img/arrow.gif'
			});

			// Add a node change handler, selects the button in the UI when a image is selected
			ed.onNodeChange.add(function(ed, cm, n) {
				cm.setActive('multifeedfields', n.nodeName == 'IMG');
			});*/
		},

		/**
		 * Creates control instances based in the incomming name. This method is normally not
		 * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
		 * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
		 * method can be used to create those.
		 *
		 * @param {String} n Name of the control to create.
		 * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
		 * @return {tinymce.ui.Control} New control instance or null if no control was created.
		 */
		createControl : function(n, cm) {
			switch (n) {
                case 'multifeedfields':
                    var mlb = cm.createListBox('multifeedfields', {
                        title : 'Fields',
                        onselect : function(v) {
								tinyMCE.activeEditor.execCommand('mceInsertContent', false, v);
								return false;
                        }
                    });
					for ( var i=1, len=fields.length; i<len; ++i ){
						mlb.add(fields[i], '#'+i+'#');
					}

                // Return the new listbox instance
                return mlb;
            }
            return null;
		},

		/**
		 * Returns information about the plugin as a name/value array.
		 * The current keys are longname, author, authorurl, infourl and version.
		 *
		 * @return {Object} Name/value array containing information about the plugin.
		 */
		getInfo : function() {
			return {
				longname : 'multifeedfields insert image plugin'
			};
		}
	});

	// Register plugin
	tinymce.PluginManager.add('multifeedfields', tinymce.plugins.multifeedfields);
})();

