<?php
/*
#################################################################################

Plugin Name: Feed Poster

Plugin URI: http://www.internetallrounder.de/

Version: 2.06

Author: 

Author URI: http://www.internetallrounder.de/

Description: Allows creation of blog posts from Multiple Comma, Pipe and Tab Separated datafeeds, XML and RSS feeds, including Auto blog feature.

#################################################################################

Version History

2.06	Added Support for All In One SEO Plugin					26 Feb 2011
		Made the URL Masking optional
		Fixed bug with the filtering system
		Fixed bugs with Wordpress 3.1

2.05	Major Release											05 July 2010
		Full XML and RSS Support
		Ajax Post processor
		Bug Fixes for special characters in URLs
		Bug Fixes for special characters in post body

2.04	Minor bug fix link cloaking - added URL encoding to 	14 June 2010
		stop issues with non-url friendly characters

2.03	Minor bug fix for Version 5.1.37 of MySQL				06 June 2010
	 	Added Link Cloaking
	 	Added Click Tracking to Dashboard

2.02 	Minor bug fixes to the database login and warnings		13 January 2010
		Fixed issue with Scheduler on some environments

2.01 	Minor Bug Fixes to the filters and DB creation          17 December 2009

2.0 	Launch of the multifeed plugin               			01 December 2009

1.0 	Added get file from URL                         		05 October 2009

0.9 	Added Pipe and Tab file support                         20 September 2009
		Added Scheduled posting support

0.8     Made Wordpress 2.8 Compatiable              			28 June 2009

0.7     Fixed Re-Upload Issue                       			19 March 2009

0.6     First Public Release                                   		14 March 2009


#################################################################################

*/

define('DQ_MULTIFEED_ABSPATH', dirname(__FILE__).'/');
define('DQ_MULTIFEED_URL', plugin_dir_url(__FILE__));
if(!class_exists('parseCSV')){
	require_once(DQ_MULTIFEED_ABSPATH.'lib/parsecsv.lib.php');
}
// multifeed plugin
if (!class_exists('multiFeed')) {
    class multiFeed	{

var $plugin_db_version = "1.9.4";
		/**
		* PHP 4 Compatible Constructor
		*/
		function multiFeed(){
		  $this->__construct();
        }

		/**
		* PHP 5 Constructor
		*/
		function __construct(){
			global $wpdb, $wp_version;
/*                    if(get_option('dq_multifeed_install')===1){
                        $feed_query = "select 1 from " . $wpdb->prefix . "multifeed";
                        if(!$wpdb->get_row($feed_query))
                        {
                                echo "<div class='error'><p>Your MySQL user does not have the relevant priviledges to create tables please add these priviledges and re-activate the plugin</p></div>";
                        }
                        update_option('dq_multifeed_install',0);
                    }*/
            // check to make sure wp version is above 2.7
       		$exit_msg= 'multiFeed requires WordPress 2.8 or newer. <a href="http://codex.wordpress.org/Upgrading_WordPress">Please update!</a>';

            if (version_compare($wp_version,"2.8","<"))
    		{
	    		exit ($exit_msg);
	    	}
            // if we get this far, wp version is 2.8 or above to initialise the script
            //$this->uri = WP_PLUGIN_URL."/".$this->directory;

            // installation / un-install scripts
            register_activation_hook(__FILE__,array(&$this,"install_on_activation"));
            //register_deactivation_hook(__FILE__,array(&$this,"uninstall_on_deactivation"));
		   if(get_option( "multifeed_queuestat" )===false)
		   		add_option( "multifeed_queuestat" );
		   if(get_option( "multifeed_queue" )===false)
		   		add_option( "multifeed_queue" ,array());

            add_action( 'admin_head', array( $this, 'admin_head' ));
            add_action( 'admin_footer', array( $this, 'admin_footer' ));
            add_action( 'admin_menu', array( $this, 'admin_menu' ));
            add_action( 'admin_init', array( $this, 'admin_init' ));
            add_action( 'my_daily_function_hook', array( $this, 'my_daily_function' ));
            add_filter( 'cron_schedules', array( $this, 'more_reccurences' ));
    		add_filter('query_vars', array($this,'query_vars'));
            add_action('plugins_loaded',array($this,'plugins_loaded'));
            add_action('wp_dashboard_setup', array( $this, 'admin_widget_setup') );
            add_action('wp_ajax_get_queue_multifeed',array($this, 'get_queue'));
			add_action('wp_ajax_exec_daemon_multifeed',array($this, 'exec_daemon'));

            // rest will go in specific table
            $this->checkOptions();

            // we will need a temporary directory, so lets create it, if it does not exist
            $this->checkTemp();
            
       }
	   
	    function exec_daemon()
        {
            global $wpdb;
			$procs=get_option('multifeed_queue');
			update_option('multifeed_queue',array());
			$count=sizeof($procs);
			$i=1;
			foreach ($procs as $proc){
				echo "Task $i<br/>";
				flush();
				include_once(DQ_MULTIFEED_ABSPATH . 'scripts/multifeed.class.php');
				$mfeed=new mFeed();
				echo $mfeed->process_file( $proc['start'], $proc['finish'], $proc['feedID'] )."<br/>";
			}
			update_option( "multifeed_queuestat" ,'');
			die;
        }
	   
	   function get_queue()
	   {
		    echo get_option( "multifeed_queuestat" );
            die();
	   }
       
       function admin_widget()
       {
       		global $wpdb;
			$query = "SELECT * FROM " . $wpdb->prefix . "multifeed_urlsx ORDER by count DESC LIMIT 0,5";
			$result = $wpdb->get_var("SELECT count(*) FROM " . $wpdb->prefix . "multifeed_urlsx");
		// now parse them for display , and return the result
		if ($result > 0) {
		$string = '';
		foreach($wpdb->get_results($query) as $data) {
			$string.="<tr><td>{$data->old_link}</td><td>{$data->count} times</td></tr>";
		}
		} else {
		$string = '<tr><td colspan="2">Not yet available</td></tr>';
		}
?>
<table class="download_chart" style="margin-bottom:0" summary="Most visited link" cellpadding="0" cellspacing="0">
<tr>
<th scope="col" width="300px">&nbsp;Link </th>
<th scope="col">&nbsp;Visited </th>

</tr>
<?php
echo $string;
?>
</table>
<?php
       	
       }
       
       function admin_widget_setup()
       {
       		wp_add_dashboard_widget( 'multifeed_stats_widget', __( 'Multifeed Click Stats' ), array( $this, 'admin_widget') );
       }
       
       function plugins_loaded()
       {
       		if(isset($_GET['link'])&&$_GET['link']&&strpos($_SERVER['HTTP_USER_AGENT'],'WordPress')===false&&!isset($_GET['id']) ){
       			global $wpdb;
	   			$url=$wpdb->get_row("select * from `" . $wpdb->prefix . "multifeed_urlsx` where new_link='{$_GET['link']}'");
	   			$wpdb->query("update `" . $wpdb->prefix . "multifeed_urlsx` set count=count+1 where id={$url->id}");
       			header('location:'.$url->old_link);
	       		die;
       		}elseif(isset($_GET['link'])&&$_GET['link']&&!isset($_GET['id'])){
       			global $wpdb;
       			$url=$wpdb->get_row("select * from `" . $wpdb->prefix . "multifeed_urlsx` where new_link='{$_GET['link']}'");
       			header('location:'.$url->old_link);
	       		die;
			}
       }
       
       function query_vars($a)
       {
       		$a[]='link';
       		return $a;
       }
       function checkOptions() {
            // will will store some settings in the wp_options table, rest will go in
            // their own database table
            define( 'MULTIFEED_PLUGIN_OPTIONS', 'MULTIFEED_PLUGIN_OPTIONS' );
            $options = get_option( MULTIFEED_PLUGIN_OPTIONS );
            if ( !$options ) {
              $options = array( );
              update_option( MULTIFEED_PLUGIN_OPTIONS, $options );
            }
       }

       function checkTemp() {
            if (!is_dir(ABSPATH . 'wp-content/uploads/tmp')) {
                if(!is_dir(ABSPATH . 'wp-content/uploads'))
	            mkdir(ABSPATH . 'wp-content/uploads');
                mkdir(ABSPATH . 'wp-content/uploads/tmp');
            }
       }

       // integrate tinymce
	   function wp_tiny_mce( $a ) {
		wp_tiny_mce( true );
	   }

	   // add increased intervals for cron jobs
	   function more_reccurences( ) {
		return array( 'weekly' => array( 'interval' => 604800, 'display' => 'Once Weekly' ), 'yearly' => array( 'interval' => 31536000, 'display' => 'Once Yearly' ), );
	   }


function admin_init( ) {
    if ( isset ($_GET['page'])&&$_GET['page'] == 'multiFeed' ) {
        add_action( 'admin_head', array( $this, 'wp_tiny_mce' ));
        add_filter( 'teeny_mce_buttons', array( $this, 'teeny_mce_buttons' ));
        wp_enqueue_script( 'page' );
        if(!file_exists(ABSPATH.'wp-content/uploads'))
        {
            echo "<div class='error'><p>wp-content/uploads folder does not exist, please create one</p></div>";
        }
        elseif(!is_writable(ABSPATH.'wp-content/uploads'))
        {
            echo "<div class='error'><p>wp-content/uploads folder is not writable by the plug-in please change its permissions</p></div>";
        }
        if(get_option('multifeed_db_version')!=$this->plugin_db_version)
        {
            $this->install_on_activation();
        }
    }
    if(is_admin()) {
        wp_enqueue_script('accordion', DQ_MULTIFEED_URL."scripts/accordion.js", array('jquery'), '1.8.0');
        wp_enqueue_script('dimensions', DQ_MULTIFEED_URL."scripts/dimensions.js", array('jquery'), '1.8.0');
        wp_enqueue_script('easing', DQ_MULTIFEED_URL."js/jquery.easing.1.3.js", array('jquery'), '1.8.0');
        wp_enqueue_script('colorbox', DQ_MULTIFEED_URL."js/jquery.colorbox.js", array('jquery'), '1.8.0');
        wp_enqueue_script('qtip',DQ_MULTIFEED_URL."js/jquery.qtip.js", array('jquery'), '1.8.0');
        if ( isset ($_GET['page'])&&(($_GET['page'] == 'edit_form') || ($_GET['page'] == 'start') || ($_GET['page'] == 'delete_form') )) {
            add_filter('admin_head',array( $this, 'ShowTinyMCE') );
        }
    }
}

function teeny_mce_buttons( $array ) {
    return array_merge( array( 'forecolor', 'charmap' ), $array );
}

function admin_menu( ) {
    add_submenu_page( 'post.php', 'multiFeed', 'Post From Feeds', 1, 'multiFeed', array( $this, 'startpage' ));
    add_submenu_page( '', "", "<span style='display: none; '>EditForm</span>", 0, "edit_form", array(&$this,"output_edit_page"));
    add_submenu_page( '', "", "<span style='display: none; '>StartForm</span>", 0, "start", array(&$this,"output_start_page"));
    add_submenu_page( '', "", "<span style='display: none; '>DeleteForm</span>", 0, "delete_form", array(&$this,"output_start_page1"));
}

function admin_head() {
    echo "<link rel='stylesheet' href='".DQ_MULTIFEED_URL."js/colorbox.css' type='text/css' media='all' />";
    if (isset ($_GET['page'])&&( ($_GET['page'] == 'edit_form') || ($_GET['page'] == 'start') || ($_GET['page'] == 'delete_form') )) {
        $this->add_css();
        $this->add_js();
    }
        if(isset($_GET['page'])&&$_GET['page'] == 'multiFeed'){
            ?>
        <script type="text/javascript" >
        jQuery(document).ready(function($) {
                var data = {
                        action: 'exec_daemon_multifeed'
                };
                jQuery.post(ajaxurl, data,function(response) {
                        jQuery("#queuestat2").html(response);
                });
          update_queue_stat();
        });
        function update_queue_stat(){
                var data = {
                        action: 'get_queue_multifeed'
                };

                jQuery.post(ajaxurl, data, function(response) {
                        jQuery("#queuestat").html(response);
                });
                setTimeout("update_queue_stat()",3000);
        }
        </script>
        <?php
        }
}

function ShowTinyMCE() {
// conditions here
    wp_enqueue_script( 'common' );
    wp_enqueue_script( 'jquery-color' );
    wp_print_scripts('editor');
    if (function_exists('add_thickbox')) add_thickbox();
        wp_print_scripts('media-upload');
    if (function_exists('wp_tiny_mce')) wp_tiny_mce();
        wp_admin_css();
    wp_enqueue_script('utils');
    do_action("admin_print_styles-post-php");
    do_action('admin_print_styles');
}

function admin_footer() {
}

	    function my_daily_function( $array ) {
		    global $wpdb, $options;
			$filename = time( );
		if(is_array($array))
	            $id = $array['id'];
		else $id=$array;
            // grab the url from the database, relative to the Id passed to the function
            $feed_query = "SELECT * FROM " . $wpdb->prefix . "multifeed WHERE id = '" . $id . "'";
            $feed = $wpdb->get_row($feed_query);
            $url = $feed->url;
            
                    // now we need to grab the file and process
        $openUrl = @fopen($url, "r");
        if(!$openUrl) return;
        $buffer = "";
        $buffer = stream_get_contents( $openUrl );
        if (substr($buffer, 0, 2) == 'PK') {
           $ext =  '.zip';
           $tmp_name = 'tmp_' . time() . $ext;
           $dloadFile = rtrim( ABSPATH, '/' ) . '/wp-content/uploads/tmp/' . $tmp_name;
        } else {
           $ext = '.tmp';
           $tmp_name = 'tmp_' . time() . $ext;
           $dloadFile = rtrim( ABSPATH, '/' ) . '/wp-content/uploads/' . $tmp_name;
        }
        file_put_contents( $dloadFile, $buffer );
        flush();
        if ( (substr ($dloadFile, -3) ) == 'zip' ) {
            $working_dir = ABSPATH . 'wp-content/uploads/';
            $ffilename = $dloadFile;
            $zip = new ZipArchive;
            $res = $zip->open($ffilename);
            $data_result = $zip->statIndex(0);
            $new_name = $data_result['name'];
            if ($res === TRUE) {
                $zip->extractTo($working_dir);
                $zip->close();
                $filename = 'datafeed_' . time() . '.tmp';
                if (!rename($working_dir . $new_name, $working_dir . $filename) ) {
                        echo '<br>Could not rename /copy Uploaded file, please try again';
                }
                $ffilename = rtrim( ABSPATH, '/' ) . '/wp-content/uploads/' . $filename;
            }
        } else {

            $filename = $tmp_name;
            $ffilename = $dloadFile;
        }
		$csv = new parseCSV();
		$csv->auto($ffilename);
		$fields=$csv->titles;
        $new_fields = '';
        while (list($key, $val) = each($fields)) {
             $new_fields .= $key .',' . $val . '|';
        }
        $new_fields = substr($new_fields, 0, -1);
        $lines = sizeof($csv->data);
        $data_array = array('file' =>  $filename ,
                            'fields' => $new_fields,
                            'file_lines' => $lines);

        $data_table = $wpdb->prefix . "multifeed";
        $clause = array('id' => $id );
        $wpdb->update($data_table, $data_array, $clause);
        include(DQ_MULTIFEED_ABSPATH . 'scripts/autprocess.php');
        $process = new autoProcess();
        $result = $process->process_file_automated( $id );
    }


function install_on_activation() {
    global $wpdb;
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            // try calling the install script
	if(get_option('multifeed_db_version')<'1.9.4'){
    $sql_install =  "CREATE TABLE " . $wpdb->prefix . "multifeed_tmp (
                                            id int(11) NOT NULL AUTO_INCREMENT,
                                            title varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            file varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            `fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            file_lines int(15) default'0',
                                            post_content text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            post_title text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            tags text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            categories text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            remove int(2) default'0',
                                            isunique varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            one varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            custom_names text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            custom_values text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            chkshed smallint(2) default'0',
                                            noofposts int(10) default'0',
                                            post_int int(10) default'0',
                                            comment_status smallint(2) default'0',
                                            ping_status smallint(2) default'0',
                                            usecondition varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            localfile text CHARACTER SET utf8 COLLATE utf8_unicode_ci ,
                                            url text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            file_date timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                            advanced varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            start varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            finish varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            slt_intrtype varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            post_ids text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            del_old int(1),
                                            PRIMARY KEY  (id)
                                          ) ;";
     dbDelta($sql_install);
	$wpdb->query("insert `" . $wpdb->prefix . "multifeed_tmp` (select * from `" . $wpdb->prefix . "multifeed`)");
//	$old=$wpdb->get_results("select * from `" . $wpdb->prefix . "multifeed`");
//	foreach($old as $row){
//		$wpdb->query("insert `" . $wpdb->prefix . "multifeed_urlsx` values({$row->id},'{$row->new_link}','{$row->old_link}',{$row->count})");
//	}
    $wpdb->query("DROP TABLE if exists " . $wpdb->prefix . "multifeed");
    $sql_install =  "CREATE TABLE " . $wpdb->prefix . "multifeed (
    id int(11) NOT NULL AUTO_INCREMENT,
    title varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    file varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    `fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    file_lines int(15) default'0',
    post_content text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    post_title text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    tags text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    categories text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    remove int(2) default'0',
    isunique varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    one varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    custom_names text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    custom_values text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    chkshed smallint(2) default'0',
    noofposts int(10) default'0',
    post_int int(10) default'0',
    comment_status smallint(2) default'0',
    ping_status smallint(2) default'0',
    usecondition varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    localfile text CHARACTER SET utf8 COLLATE utf8_unicode_ci ,
    url text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    file_date timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
    advanced varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    start varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    finish varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    slt_intrtype varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
    post_ids text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
    del_old int(1),
	aio_keywords text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_title text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_description text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_meta text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_titleatr text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_menulabel text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
	aio_disable int(1),
	enable_url_masking int(1) default '1',
    PRIMARY KEY  (id)
) ;";
     dbDelta($sql_install);
	$wpdb->query("insert `" . $wpdb->prefix . "multifeed` (select * from `" . $wpdb->prefix . "multifeed_tmp`)");
    $wpdb->query("DROP TABLE if exists " . $wpdb->prefix . "multifeed_tmp");
	}
    $sql_install =  "CREATE TABLE " . $wpdb->prefix . "multifeed (
                                            id int(11) NOT NULL AUTO_INCREMENT,
                                            title varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            file varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            `fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            file_lines int(15) default'0',
                                            post_content text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            post_title text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            tags text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            categories text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            remove int(2) default'0',
                                            isunique varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            one varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            custom_names text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            custom_values text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            chkshed smallint(2) default'0',
                                            noofposts int(10) default'0',
                                            post_int int(10) default'0',
                                            comment_status smallint(2) default'0',
                                            ping_status smallint(2) default'0',
                                            usecondition varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            localfile text CHARACTER SET utf8 COLLATE utf8_unicode_ci ,
                                            url text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            file_date timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                            advanced varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            start varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            finish varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            slt_intrtype varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci default '',
                                            post_ids text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                                            del_old int(1),
											aio_keywords text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
											aio_title text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
											aio_description text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
											aio_meta text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
											aio_titleatr text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
											aio_menulabel text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
        									aio_disable int(1),
											enable_url_masking int(1) default '1',
		                                    PRIMARY KEY  (id)
                                          )";
     dbDelta($sql_install);
	$sql_install =  "CREATE TABLE `" . $wpdb->prefix . "multifeed_rules` (
                              `id` int(11) NOT NULL auto_increment,
                              `feed_id` int(11) NOT NULL,
                              `field` int(11) NOT NULL,
                              `and_or` int(1) NOT NULL,
                              `contains` int(1) NOT NULL,
                              `str` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
                              PRIMARY KEY  (`id`)
                            );";
    dbDelta($sql_install);
    $sql_install =  "CREATE TABLE `" . $wpdb->prefix . "multifeed_urlsx` (
                              `id` int(11) NOT NULL auto_increment,
                              `new_link` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                              `old_link` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
                              `count` int(11) NOT NULL,
                              PRIMARY KEY  (`id`)
                            );";
    dbDelta($sql_install);
	$old=$wpdb->get_results("select * from `" . $wpdb->prefix . "multifeed_urls`");
	foreach($old as $row){
		$wpdb->query("insert `" . $wpdb->prefix . "multifeed_urlsx` values({$row->id},'{$row->new_link}','{$row->old_link}',{$row->count})");
	}
    update_option('multifeed_db_version',$this->plugin_db_version);
    update_option('dq_multifeed_install',1);
}

function uninstall_on_deactivation() {
    global $wpdb;
            // drop the database table as required
    $wpdb->query("DROP TABLE if exists " . $wpdb->prefix . "multifeed");
    return true;
}

function startpage() {
    global $wpdb;
    $options = get_option( MULTIFEED_PLUGIN_OPTIONS );
    include(DQ_MULTIFEED_ABSPATH . 'pages/templates.php');
}

function output_edit_page(){
    include('pages/edit_form.php'); // dispaly the user details edit page
}

function output_start_page(){
    include('pages/start.php'); // dispaly the user details edit page
}

function output_start_page1(){
    include('pages/delete_form.php'); // dispaly the user details edit page
}

	function add_css() {

		$css = array();

		$css[] = '#header-logo';
		$css[] = '#wphead'; // In 2.8+ this just needs to be: #wphead #site-visit-button
		$css[] = '#favorite-actions';
		$css[] = '#contextual-help-link-wrap'; // This is just for < WP2.8, since 2.8 modifies this via JS
		$css[] = '#footer-left';
		$css[] = '#footer-upgrade';
		$css[] = '#menu-dashboard';
		$css[] = '#adminmenu';
		$css[] = '#icon-index, .icon32';
		$css[] = '#user_info p > a[href=\'profile.php\']';

		// Hack
		$extra_css = '#wphead #site-title { display:none; }';
        $extra_css2 = '#adminmenu {margin-left: -45px;}';
        $extra_css3 = '#wpbody {margin-left: 5px;}';
			$css = implode(', ', $css);
			echo <<<CSS
		<style type="text/css">
		{$css} { display:none; }
		{$extra_css}
        {$extra_css2}
        {$extra_css3}
		</style>
CSS;
	}

	function add_js() {

		$js = array();
		$js[] = "\$('.wp-menu-separator:first').remove();";
		$js[] = "\$('.turbo-nag').remove();";
		$js[] = "\$('#user_info p').after('<p></p>');";
		$js[] = "\$('#user_info p > a, #user_info p > span').appendTo($('#user_info p:last'));";
		$js[] = "\$('#user_info p:first').remove();";
		$js[] = "\$('#contextual-help-link-wrap').remove();";
		$js[] = "\$('.turbo-nag').html(\$('.turbo-nag a'))";
		$js[] = "\$('#user_info p a:last').before(' | ');";

			$js = implode("\n", $js);
 		echo <<<JS
		<script type="text/javascript">
		jQuery(document).ready(function($) {
			{$js}
		});
		</script>
JS;
		}


   }   // end of class descriptor

  } // end of class duplicate detection



// now if class exists, initiate it
if (class_exists('multiFeed')) {
	$multiFeed = new multiFeed();
}

function multifeed_addbuttons() {
   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
 
   if ( get_user_option('rich_editing') == 'true') {
     add_filter("mce_external_plugins", "add_multifeed_tinymce_plugin");
     add_filter('mce_buttons', 'register_multifeed_button');
   }
}
 
function register_multifeed_button($buttons) {
   array_push($buttons, "separator", "multifeed");
   return $buttons;
}
 
function add_multifeed_tinymce_plugin($plugin_array) {
   $plugin_array['multifeed'] = DQ_MULTIFEED_URL.'editor_plugin.js';
   return $plugin_array;
}
function getXMLKeys($xml,$start=false)
{
	$keys=array();
    foreach($xml as $k=>$v){
    	if(is_array($v)){
        	if(is_numeric($k)){
            	$start=true;
            }
            $keys=array_merge($keys,getXMLKeys($v,$start));
        }elseif($start){
        	$keys[]=$k;
        }
    }
    return array_unique($keys);
}
function getXMLLines($xml,$start=false)
{
	$keys=array();
    $lines=0;
    foreach($xml as $k=>$v){
    	if(is_array($v)||is_object($v)){
        	if(is_numeric($k)){
            	$start=true;
                $lines++;
            }
            $lines+=getXMLLines($v,$start);
        }
    }
    return $lines;
}
function getXMLDataRoot($xml)
{
    foreach($xml as $k=>$v){
    	if(is_array($v)||is_object($v)){
        	if(is_numeric($k)){
            	return $xml;
            }
            else{
            	if(is_array($res=getXMLDataRoot($v))){
                	return $res;
                }
            }
        }
    }
    return null;
}
function objectToArray( $object )
{
    if( !is_object( $object ) && !is_array( $object ) )
    {
        return $object;
    }
    if( is_object( $object ) )
    {
        $object = get_object_vars( $object );
    }
    return array_map( 'objectToArray', $object );
}
add_action('init', 'multifeed_addbuttons');

?>
