<?php
/**
 * add to init dynamically
 *
 * @global type $config_options
 * @global type $smartPaginate
 */
function smartPaginate_config_option_fields() {
    global $tagcloud_options, $smartPaginate;
    $prefix = $smartPaginate->prefix;

    $options = array();

    /* Tab - CountDown - datapicker */
    $options[] = array(
        "name" => "Layout",
        "type" => "tab",
        "id" => "smartLayout"
    );

    $options[] = array(
        "name" => "General design settings:",
        "type" => "title",
        "styles" => "margin-top: 16px;"
    );
    $options[] = array(
        "name" => "General style",
        "type" => "radiobutton_files",
        "path" => "modules/styles/load.php",
        "id" => "{$prefix}" . "_" . "config" . "_" . "style"
    );

	$options[] = array(
        "name" => "Next/Previous label:",
        "type" => "title",
        "styles" => "margin-top: 16px;"
    );
	
	$options[] = array(
        "name" => "Next label:",
        "desc" => 'Default: ' . htmlentities('Next &raquo;'),
        "id" => "{$prefix}" . "_" . "config" . "_" . "label_next",
        "std" => "",
		"width" => "40",
        "type" => "text"
    );
	$options[] = array(
        "name" => "Previous label:",
        "desc" => 'Default: ' . htmlentities('&laquo; Previous'),
        "id" => "{$prefix}" . "_" . "config" . "_" . "label_prev",
        "std" => "",
		"width" => "40",
        "type" => "text"
    );
	
	$options[] = array(
        "name" => "Custom styles:",
        "type" => "title",
        "styles" => "margin-top: 16px;"
    );
    $options[] = array(
        "name" => "Link text - color:",
        "desc" => 'Pick your color',
        "id" => "{$prefix}" . "_" . "config" . "_" . "link_fontcolor",
        "std" => "",
        "type" => "colorpicker"
    );
    $options[] = array(
        "name" => "Current item (not link) text - color:",
        "desc" => 'Pick your color',
        "id" => "{$prefix}" . "_" . "config" . "_" . "curr_fontcolor",
        "std" => "",
        "type" => "colorpicker"
    );
    $options[] = array(
        "name" => "Hover link text - color:",
        "desc" => 'Pick your color',
        "id" => "{$prefix}" . "_" . "config" . "_" . "hover_fontcolor",
        "std" => "",
        "type" => "colorpicker"
    );
    $options[] = array(
        "name" => "Font family:",
        "desc" => 'Choose from list',
        "id" => "{$prefix}" . "_" . "config" . "_" . "fontfamily",
        "std" => "",
        "options" => $smartPaginate->fonts(),
        "type" => "select"
    );
    $options[] = array(
        "name" => "Font size:",
        "desc" => 'Default: <b>12px</b>',
        "id" => "{$prefix}" . "_" . "config" . "_" . "font_size",
        "std" => "",
        "type" => "text",
        "width" => "10"
    );
    $options[] = array(
        "name" => "Show border:",
        "desc" => 'Default: true',
        "id" => "{$prefix}" . "_" . "config" . "_" . "border_show",
        "std" => "",
        "options" => array('', 'Yes', 'No'),
        "type" => "radio"
    );
    $options[] = array(
        "name" => "Border color:",
        "desc" => 'Pick your color',
        "id" => "{$prefix}" . "_" . "config" . "_" . "border_color",
        "std" => "",
        "type" => "colorpicker"
    );

    $options[] = array(
        "name" => "Advanced settings",
        "type" => "tab",
        "id" => "smartBrAdvanceSettings"
    );
    $options[] = array(
        "name" => "Gap:",
        "desc" => 'From how many item display gap points? Default: 3',
        "id" => "{$prefix}" . "_" . "config" . "_" . "gap",
        "std" => "",
        "options" => range(1, 20),
        "type" => "select",
        "width" => "10"
    );
	$options[] = array(
        "name" => "Range:",
        "desc" => 'Default: 5',
        "id" => "{$prefix}" . "_" . "config" . "_" . "range",
        "std" => "",
        "options" => range(1, 30),
        "type" => "select",
        "width" => "10"
    );
	$options[] = array(
        "name" => "Anchor:",
        "desc" => 'Default: 1',
        "id" => "{$prefix}" . "_" . "config" . "_" . "anchor",
        "std" => "",
        "options" => range(1, 20),
        "type" => "select",
        "width" => "10"
    );
    /* END tagcloud_option_fields() */
    update_option("{$smartPaginate->prefix}_tagcloud_options", $options);

    return $options;
}