<?php
class smartPaginateFrontpage {
    public  $options; // array containing the optionsions
    private $smartPaginate;
    public  $curr_style;
    
    // default type
    public  $type = 'posts';

    function __construct() {
        // plugin class
        $this->smartPaginate = $GLOBALS['smartPaginate_plugin'];

        $this->options = array(
            'url_home' => home_url("/"),
            'title'         => 'Pages:',
            'nextpage'      => trim($this->smartPaginate->get_option('_config_' . 'label_next')) != "" ? $this->smartPaginate->get_option('_config_' . 'label_next') : 'Next &raquo;',
            'previouspage'  => trim($this->smartPaginate->get_option('_config_' . 'label_prev')) != "" ? $this->smartPaginate->get_option('_config_' . 'label_prev') : '&laquo; Previous',
            'before'        => '<div class="navigation">',
            'after'         => '</div>',
            'empty'         => true,
            'range'         => trim($this->smartPaginate->get_option('_config_' . 'range')) 	!= "" ? $this->smartPaginate->get_option('_config_' . 'range') : 5,
            'anchor'        => trim($this->smartPaginate->get_option('_config_' . 'anchor')) 	!= "" ? $this->smartPaginate->get_option('_config_' . 'anchor') : 1,
            'gap'           => trim($this->smartPaginate->get_option('_config_' . 'gap')) 		!= "" ? $this->smartPaginate->get_option('_config_' . 'gap') : 3
        );
        
		
		//var_dump('<pre>',$this->options 	,'</pre>'); die; 
        foreach ($this->options as $key => $value) {
            if ($value == 'true') {
                $this->options[$key] = true;
            }
            if ($value == 'false') {
                $this->options[$key] = false;
            }
        }
        
        // add css
        add_action('wp_print_styles', array(&$this, 'wp_paginate_css'));
    }

    /**
     * Pagination based on options
     */
    function paginate($args = false) {
        if ($this->type === 'comments' && !get_option('page_comments'))
            return;

        $r = wp_parse_args($args, $this->options);
        extract($r, EXTR_SKIP);

        if (!isset($page) && !isset($pages)) {
            global $wp_query;

            if ($this->type === 'posts') {
                $page = get_query_var('paged');
                $posts_per_page = intval(get_query_var('posts_per_page'));
                $pages = intval(ceil($wp_query->found_posts / $posts_per_page));
            } else {
                $page = get_query_var('cpage');
                $comments_per_page = get_option('comments_per_page');
                $pages = get_comment_pages_count();
            }
            $page = !empty($page) ? intval($page) : 1;
        }

        $prevlink = ($this->type === 'posts') ? esc_url(get_pagenum_link($page - 1)) : get_comments_pagenum_link($page - 1);
        $nextlink = ($this->type === 'posts') ? esc_url(get_pagenum_link($page + 1)) : get_comments_pagenum_link($page + 1);

       
        // get current style
        $curr_style = str_replace("preview.png", '', $this->smartPaginate->get_option('_config_' . 'style'));
        
        $model = str_replace("/", '', str_replace("style", '', $curr_style));
        $this->curr_style = $this->smartPaginate->cfg('PLUGIN_MODULES_URL') . 'styles' . '/' . $curr_style . 'css.css'; 
       
		if($this->smartPaginate->get_option('_config_' . 'fontfamily') != 'arial'){
            echo '<link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=' . $this->smartPaginate->get_option('_config_' . 'fontfamily') . '">' . PHP_EOL;
        }
		
        $output = '<link rel="stylesheet" type="text/css" media="all" href="' . $this->curr_style . '" />' . PHP_EOL;
        $output .= '<style type="text/css">' . PHP_EOL;
        $output .=    'ul#pagination.' . ($model) . ' {border-color: ' . ($this->smartPaginate->get_option('_config_' . 'border_color')) . ';}' . PHP_EOL;
        $output .=    'ul#pagination.' . ($model) . ' li {font-size: ' . ( (int) $this->smartPaginate->get_option('_config_' . 'font_size') ) . 'px;}' . PHP_EOL;
        
        $output .=    'ul#pagination.' . ($model) . ' li a:link, ul#pagination.' . ($model) . ' li a:visited {color: ' . ($this->smartPaginate->get_option('_config_' . 'link_fontcolor')) . ';}' . PHP_EOL;
        $output .=    'ul#pagination.' . ($model) . ' li a:hover {color: ' . ($this->smartPaginate->get_option('_config_' . 'hover_fontcolor')) . ';}' . PHP_EOL;
        $output .=    'ul#pagination.' . ($model) . ' li.active {color: ' . ($this->smartPaginate->get_option('_config_' . 'curr_fontcolor')) . ';}' . PHP_EOL;
		
		if($this->smartPaginate->get_option('_config_' . 'border_show') != 1){
            $output .= 'ul#pagination.' . ($model) . ' {border: none}';
        }
		if($this->smartPaginate->get_option('_config_' . 'fontfamily') != 'arial'){
			$output .= "
				ul#pagination.{$model} li {
					font-family: '".($this->smartPaginate->get_option('_config_' . 'fontfamily'))."', Arial, serif;
				}
			";
		}
        $output .= '</style>' . PHP_EOL; 
        
        $output .= stripslashes($before);
        if ($pages > 1) {
            $output .= '<ul class="' . ($model) .'" id="pagination">' . PHP_EOL;
            
            $ellipsis = "<li><a href='javascript://'>...</a></li>" . PHP_EOL;
            if ($page > 1 && !empty($previouspage)) {
                $output .= sprintf('<li class="previous-off"><a href="%s">%s</a></li>', $prevlink, stripslashes($previouspage));
            }

            $min_links = $range * 2 + 1;
            $block_min = min($page - $range, $pages - $min_links);
            $block_high = max($page + $range, $min_links);
            $left_gap = (($block_min - $anchor - $gap) > 0) ? true : false;
            $right_gap = (($block_high + $anchor + $gap) < $pages) ? true : false;

            if ($left_gap && !$right_gap) {
                $output .= sprintf('%s%s%s', $this->paginate_loop(1, $anchor), $ellipsis, $this->paginate_loop($block_min, $pages, $page)
                );
            } else if ($left_gap && $right_gap) {
                $output .= sprintf('%s%s%s%s%s', $this->paginate_loop(1, $anchor), $ellipsis, $this->paginate_loop($block_min, $block_high, $page), $ellipsis, $this->paginate_loop(($pages - $anchor + 1), $pages)
                );
            } else if ($right_gap && !$left_gap) {
                $output .= sprintf('%s%s%s', $this->paginate_loop(1, $block_high, $page), $ellipsis, $this->paginate_loop(($pages - $anchor + 1), $pages)
                );
            } else {
                $output .= $this->paginate_loop(1, $pages, $page);
            }

            if ($page < $pages && !empty($nextpage)) {
                $output .= sprintf('<li class="next"><a href="%s">%s</a></li>', $nextlink, stripslashes($nextpage));
            }
            $output .= "</ul>";
        }
        $output .= stripslashes($after);

        if ($pages > 1 || $empty) {
            echo $output;
        }
    }

    /**
     * Helper function for pagination which builds the page links.
     */
    function paginate_loop($start, $max, $page = 0) {
        $output = "";
		
		$curr_style = str_replace("preview.png", '', $this->smartPaginate->get_option('_config_' . 'style'));
        
        $model = str_replace("/", '', str_replace("style", '', $curr_style));
        for ($i = $start; $i <= $max; $i++) {
            $p = ($this->type === 'posts') ? esc_url(get_pagenum_link($i)) : get_comments_pagenum_link($i);
            $output .= ( $page == intval($i)) ? "<li class='active'>".($model == 'model-9' ? '[' : '')."$i".($model == 'model-9' ? ']' : '')."</li>" : "<li><a href='$p' title='$i'>".($model == 'model-9' ? '[' : '')."$i".($model == 'model-9' ? ']' : '')."</a></li>";
        }
        return $output;
    }
}

/**
 * Pagination function to use for posts
 */
function smart_paginate($args = false) {
    $smartPaginateFrontpage = new smartPaginateFrontpage();
    return $smartPaginateFrontpage->paginate($args);
}

/**
 * Pagination function to use for post comments
 */
function smart_paginate_comments($args = false) {
    $smartPaginateFrontpage = new smartPaginateFrontpage();
    $smartPaginateFrontpage->type = 'comments';
    return $smartPaginateFrontpage->paginate($args);
}